=== debian/changelog ===
android-platform-build (1:8.1.0+r23-3ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Mar 2020 19:25:52 +0100

android-platform-build (1:8.1.0+r23-3ubuntu1) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Jan 2020 19:47:19 +0100

android-platform-build (1:8.1.0+r23-3) unstable; urgency=medium

  * Standards-Version => 4.4.0
  * Debhelper => 12
  * Remove Build-Depends on pandoc since we use prebuilt manpages now
  * Update my email

  [ Katerina <ykaterina0319@gmail.com> ]
  * New package `makeparallel`

 -- Kai-Chung Yan <seamlik@debian.org>  Wed, 24 Jul 2019 23:26:20 +0200

android-platform-build (1:8.1.0+r23-2) unstable; urgency=medium

  * Move javahelper from Build-Depends-Indep to Build-Depends. Debhelper plugins
    must always be installed.
  * Pre-bake manpages using Pandoc during dev-time. Pandoc as a build-dependency
    is sometimes unreliable and unnecessary because Haskell uses static linking.

 -- Kai-Chung Yan <seamlikok@gmail.com>  Thu, 25 Oct 2018 21:57:20 +0800

android-platform-build (1:8.1.0+r23-1) unstable; urgency=medium

  [ Kai-Chung Yan ]
  * New upstream release
  * Use dh_auto_build to invoke makefiles (thanks to Helmut Grohne)
  * Standards-Version => 4.2.1: Remove get-orig-source
  * Remove old package android-platform-build-headers (Closes: #908801)
  * Update manpages with new contents and more appropriate formatting
  * Build signapk with apksig
  * d/copyright: Exclude minified JavaScript

  [ Hans-Christoph Steiner ]
  * Switch to Salsa
  * d/copyright: Use HTTPS URLs

 -- Kai-Chung Yan <seamlikok@gmail.com>  Wed, 24 Oct 2018 23:11:54 +0800
