## android-platform-build 10.0.0%2Br36

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,25 @@
 Source: android-platform-build
 Section: devel
 Priority: optional
-Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
 Uploaders: Kai-Chung Yan <seamlik@debian.org>,
            Hans-Christoph Steiner <hans@eds.org>,
            Chirayu Desai <chirayudesai1@gmail.com>
-Build-Depends: debhelper (>= 12~), javahelper, dh-python, python2
+Build-Depends:
+ debhelper-compat (= 12),
+ javahelper
 Build-Depends-Arch:
- android-libandroidfw-dev (>= 1:8.1.0+r23~),
- android-liblog-dev (>= 1:8.1.0+r23~),
- android-libutils-dev (>= 1:8.1.0+r23~),
+ android-libandroidfw-dev (>= 1:10.0.0+r36~),
+ android-libbase-dev (>= 1:10.0.0+r36~),
+ android-liblog-dev (>= 1:10.0.0+r36~),
+ android-libutils-dev (>= 1:10.0.0+r36~),
+ android-libziparchive-dev (>= 1:10.0.0+r36~),
  libzopfli-dev (>= 1.0.1-3),
  zlib1g-dev
 Build-Depends-Indep:
  default-jdk-headless | default-jdk,
- libapksig-java (>= 0.8-2~),
+ libapksig-java (>= 30.0.3-3~),
  libbcpkix-java,
  libbcprov-java
 Standards-Version: 4.4.0
@@ -72,7 +77,9 @@
 
 Package: android-logtags-tools
 Architecture: all
-Depends: ${python:Depends},, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ python3
 Description: Tools from AOSP that process event-log-tags files
  This package contains Python scripts from AOSP repository platform/build that
  process event-log-tags (.logtags) files. It contains:
