=== debian/changelog ===
android-platform-build (1:10.0.0+r36-1) unstable; urgency=medium

  * New upstream version (Closes: #975747)
  * fix formatting in manpages

 -- Hans-Christoph Steiner <hans@eds.org>  Sat, 02 Jan 2021 22:32:31 +0100

android-platform-build (1:8.1.0+r23-5) unstable; urgency=medium

  * port scripts to Python 3 using 2to3 (Closes: #945626)

 -- Hans-Christoph Steiner <hans@eds.org>  Mon, 12 Oct 2020 19:21:50 +0200

android-platform-build (1:8.1.0+r23-4) unstable; urgency=medium

  * Team upload.
  * debian/watch:
    - Update rule to get new upstream version.
  * Update debian/.gitlab-ci.yml to disable CI on tags.
  * d/control: Use :any annotation for python dependency.
  * debian/control:
    - Use debhelper-compat as B-D.
  * debian/rules:
    - Add security hardening.

 -- Roger Shimizu <rosh@debian.org>  Sun, 10 May 2020 17:32:25 +0900

android-platform-build (1:8.1.0+r23-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * source only upload to enable migration (Closes: #953336)

 -- Paul Gevers <elbrus@debian.org>  Sun, 08 Mar 2020 08:11:28 +0100
