=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+# Security Hardening
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 include /usr/share/dpkg/architecture.mk
 include /usr/share/javahelper/java-vars.mk
@@ -19,7 +22,7 @@
   debian/ziptime.1 \
 
 debian/%.1: debian/%.1.md
-	pandoc -s -o $@ $<
+	pandoc --standalone --from=markdown-smart --to=man --output=$@ $<
 
 all-manpages: $(MANPAGES)
 	@echo "Generated all manpages."
@@ -37,13 +40,13 @@
 	dh_auto_build --buildsystem=makefile -- --file $<
 
 signapk.jar:
-	jh_build --javacopts="-source 7" --no-javadoc --main=com.android.signapk.SignApk $@ tools/signapk/
+	jh_build --javacopts="-encoding UTF-8 -source 1.9 -target 1.9" --no-javadoc --main=com.android.signapk.SignApk $@ tools/signapk/
 
 signtos.jar:
-	jh_build --javacopts="-source 7" --no-javadoc --main=com.android.signtos.SignTos $@ tools/signtos/
+	jh_build --javacopts="-encoding UTF-8 -source 1.9 -target 1.9" --no-javadoc --main=com.android.signtos.SignTos $@ tools/signtos/
 
 %:
-	dh $@ --with javahelper,python2
+	dh $@ --with javahelper
 
 override_dh_auto_build-arch: makeparallel zipalign ziptime
